/* vnc-display.c generated by valac 0.40.15, the Vala compiler
 * generated from vnc-display.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "common.h"
#include <stdlib.h>
#include <string.h>
#include <gtk-vnc.h>
#include <libxml/uri.h>
#include <float.h>
#include <math.h>
#include <cairo.h>


#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;
typedef enum  {
	BOXES_PROPERTIES_PAGE_GENERAL,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_SNAPSHOTS,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;


#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;

#define BOXES_TYPE_DISPLAY (boxes_display_get_type ())
#define BOXES_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_DISPLAY, BoxesDisplay))
#define BOXES_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_DISPLAY, BoxesDisplayClass))
#define BOXES_IS_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_DISPLAY))
#define BOXES_IS_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_DISPLAY))
#define BOXES_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_DISPLAY, BoxesDisplayClass))

typedef struct _BoxesDisplay BoxesDisplay;
typedef struct _BoxesDisplayClass BoxesDisplayClass;
typedef struct _BoxesDisplayPrivate BoxesDisplayPrivate;
typedef gint (*BoxesDisplayOpenFDFunc) (gpointer user_data);

#define BOXES_TYPE_VNC_DISPLAY (boxes_vnc_display_get_type ())
#define BOXES_VNC_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplay))
#define BOXES_VNC_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplayClass))
#define BOXES_IS_VNC_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_VNC_DISPLAY))
#define BOXES_IS_VNC_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_VNC_DISPLAY))
#define BOXES_VNC_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplayClass))

typedef struct _BoxesVncDisplay BoxesVncDisplay;
typedef struct _BoxesVncDisplayClass BoxesVncDisplayClass;
typedef struct _BoxesVncDisplayPrivate BoxesVncDisplayPrivate;
enum  {
	BOXES_VNC_DISPLAY_0_PROPERTY,
	BOXES_VNC_DISPLAY_PROTOCOL_PROPERTY,
	BOXES_VNC_DISPLAY_URI_PROPERTY,
	BOXES_VNC_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* boxes_vnc_display_properties[BOXES_VNC_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _xmlFreeURI0(var) ((var == NULL) ? NULL : (var = (xmlFreeURI (var), NULL)))

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page);
};

struct _BoxesDisplay {
	GObject parent_instance;
	BoxesDisplayPrivate * priv;
	gboolean connected;
	GHashTable* displays;
};

struct _BoxesDisplayClass {
	GObjectClass parent_class;
	GtkWidget* (*get_display) (BoxesDisplay* self, gint n);
	GdkPixbuf* (*get_pixbuf) (BoxesDisplay* self, gint n, GError** error);
	void (*set_enable_audio) (BoxesDisplay* self, gboolean enable);
	gboolean (*should_keep_alive) (BoxesDisplay* self);
	void (*connect_it) (BoxesDisplay* self, BoxesDisplayOpenFDFunc open_fd, gpointer open_fd_target, GDestroyNotify open_fd_target_destroy_notify, GError** error);
	void (*disconnect_it) (BoxesDisplay* self);
	void (*collect_logs) (BoxesDisplay* self, GString* builder);
	void (*transfer_files) (BoxesDisplay* self, GList* uris);
	void (*send_keys) (BoxesDisplay* self, guint* keyvals, int keyvals_length1);
	GList* (*get_properties) (BoxesDisplay* self, BoxesPropertiesPage page);
	const gchar* (*get_protocol) (BoxesDisplay* self);
	gchar* (*get_uri) (BoxesDisplay* self);
	gboolean (*get_can_transfer_files) (BoxesDisplay* self);
};

struct _BoxesVncDisplay {
	BoxesDisplay parent_instance;
	BoxesVncDisplayPrivate * priv;
};

struct _BoxesVncDisplayClass {
	BoxesDisplayClass parent_class;
};

struct _BoxesVncDisplayPrivate {
	VncDisplay* display;
	gchar* host;
	gint port;
	GtkWindow* window;
	BoxesBoxConfigSavedProperty* saved_properties;
	gint saved_properties_length1;
	gint _saved_properties_size_;
};


static gpointer boxes_vnc_display_parent_class = NULL;

GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_property_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GType boxes_display_get_type (void) G_GNUC_CONST;
GType boxes_vnc_display_get_type (void) G_GNUC_CONST;
#define BOXES_VNC_DISPLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplayPrivate))
static void _vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                                   gint array_length);
BoxesVncDisplay* boxes_vnc_display_new (BoxesBoxConfig* config,
                                        const gchar* host,
                                        gint port);
BoxesVncDisplay* boxes_vnc_display_construct (GType object_type,
                                              BoxesBoxConfig* config,
                                              const gchar* host,
                                              gint port);
BoxesDisplay* boxes_display_construct (GType object_type);
void boxes_display_set_config (BoxesDisplay* self,
                               BoxesBoxConfig* value);
BoxesVncDisplay* boxes_vnc_display_new_with_uri (BoxesBoxConfig* config,
                                                 const gchar* _uri,
                                                 GError** error);
BoxesVncDisplay* boxes_vnc_display_construct_with_uri (GType object_type,
                                                       BoxesBoxConfig* config,
                                                       const gchar* _uri,
                                                       GError** error);
static GtkWidget* boxes_vnc_display_real_get_display (BoxesDisplay* base,
                                               gint n);
static void boxes_vnc_display_real_set_enable_audio (BoxesDisplay* base,
                                              gboolean enable);
static GdkPixbuf* boxes_vnc_display_real_get_pixbuf (BoxesDisplay* base,
                                              gint n,
                                              GError** error);
static void boxes_vnc_display_real_connect_it (BoxesDisplay* base,
                                        BoxesDisplayOpenFDFunc open_fd,
                                        gpointer open_fd_target,
                                        GDestroyNotify open_fd_target_destroy_notify,
                                        GError** error);
const gchar* boxes_display_get_username (BoxesDisplay* self);
const gchar* boxes_display_get_password (BoxesDisplay* self);
static void boxes_vnc_display_real_disconnect_it (BoxesDisplay* base);
static GList* boxes_vnc_display_real_get_properties (BoxesDisplay* base,
                                              BoxesPropertiesPage page);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void boxes_vnc_display_real_send_keys (BoxesDisplay* base,
                                       guint* keyvals,
                                       int keyvals_length1);
void boxes_vnc_display_scale (BoxesVncDisplay* self);
static GObject * boxes_vnc_display_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
void boxes_display_set_need_password (BoxesDisplay* self,
                                      gboolean value);
static void _boxes_vnc_display___lambda94_ (BoxesVncDisplay* self);
void boxes_display_access_start (BoxesDisplay* self);
static void __boxes_vnc_display___lambda94__vnc_display_vnc_initialized (VncDisplay* _sender,
                                                                  gpointer self);
static void _boxes_vnc_display___lambda95_ (BoxesVncDisplay* self);
void boxes_display_access_finish (BoxesDisplay* self);
static void __boxes_vnc_display___lambda95__vnc_display_vnc_disconnected (VncDisplay* _sender,
                                                                   gpointer self);
static void _boxes_vnc_display___lambda96_ (BoxesVncDisplay* self);
void boxes_display_set_need_username (BoxesDisplay* self,
                                      gboolean value);
static void __boxes_vnc_display___lambda96__vnc_display_vnc_auth_failure (VncDisplay* _sender,
                                                                   const gchar* object,
                                                                   gpointer self);
static void _boxes_vnc_display___lambda97_ (BoxesVncDisplay* self);
static void __boxes_vnc_display___lambda97__vnc_display_vnc_auth_unsupported (VncDisplay* _sender,
                                                                       guint object,
                                                                       gpointer self);
static void _boxes_vnc_display___lambda98_ (BoxesVncDisplay* self,
                                     GValueArray* creds);
const gchar* vnc_display_credential_to_string (VncDisplayCredential self);
static void __boxes_vnc_display___lambda98__vnc_display_vnc_auth_credential (VncDisplay* _sender,
                                                                      GValueArray* credList,
                                                                      gpointer self);
static void _boxes_vnc_display_scale_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self);
static void boxes_vnc_display_finalize (GObject * obj);
const gchar* boxes_display_get_protocol (BoxesDisplay* self);
gchar* boxes_display_get_uri (BoxesDisplay* self);
static void _vala_boxes_vnc_display_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);


static void
_vala_BoxesBoxConfigSavedProperty_array_free (BoxesBoxConfigSavedProperty * array,
                                              gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			boxes_box_config_saved_property_destroy (&array[i]);
		}
	}
	g_free (array);
}


BoxesVncDisplay*
boxes_vnc_display_construct (GType object_type,
                             BoxesBoxConfig* config,
                             const gchar* host,
                             gint port)
{
	BoxesVncDisplay * self = NULL;
	gchar* _tmp0_;
	VncDisplay* _tmp1_;
	BoxesBoxConfigSavedProperty* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (host != NULL, NULL);
	self = (BoxesVncDisplay*) boxes_display_construct (object_type);
	boxes_display_set_config ((BoxesDisplay*) self, config);
	_tmp0_ = g_strdup (host);
	_g_free0 (self->priv->host);
	self->priv->host = _tmp0_;
	self->priv->port = port;
	_tmp1_ = self->priv->display;
	_tmp2_ = self->priv->saved_properties;
	_tmp2__length1 = self->priv->saved_properties_length1;
	boxes_box_config_save_properties (config, (GObject*) _tmp1_, _tmp2_, _tmp2__length1);
	return self;
}


BoxesVncDisplay*
boxes_vnc_display_new (BoxesBoxConfig* config,
                       const gchar* host,
                       gint port)
{
	return boxes_vnc_display_construct (BOXES_TYPE_VNC_DISPLAY, config, host, port);
}


BoxesVncDisplay*
boxes_vnc_display_construct_with_uri (GType object_type,
                                      BoxesBoxConfig* config,
                                      const gchar* _uri,
                                      GError** error)
{
	BoxesVncDisplay * self = NULL;
	xmlURI* uri = NULL;
	xmlURI* _tmp0_;
	xmlURI* _tmp1_;
	const gchar* _tmp2_;
	xmlURI* _tmp4_;
	const gchar* _tmp5_;
	xmlURI* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_ = 0;
	xmlURI* _tmp11_;
	gint _tmp12_;
	VncDisplay* _tmp15_;
	BoxesBoxConfigSavedProperty* _tmp16_;
	gint _tmp16__length1;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (config != NULL, NULL);
	g_return_val_if_fail (_uri != NULL, NULL);
	self = (BoxesVncDisplay*) boxes_display_construct (object_type);
	boxes_display_set_config ((BoxesDisplay*) self, config);
	_tmp0_ = xmlParseURI (_uri);
	uri = _tmp0_;
	_tmp1_ = uri;
	_tmp2_ = _tmp1_->scheme;
	if (g_strcmp0 (_tmp2_, "vnc") != 0) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is not vnc://");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == BOXES_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_xmlFreeURI0 (uri);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_xmlFreeURI0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = uri;
	_tmp5_ = _tmp4_->server;
	if (_tmp5_ == NULL) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (BOXES_ERROR, BOXES_ERROR_INVALID, "the URL is missing a server");
		_inner_error0_ = _tmp6_;
		if (_inner_error0_->domain == BOXES_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_xmlFreeURI0 (uri);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_xmlFreeURI0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp7_ = uri;
	_tmp8_ = _tmp7_->server;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 (self->priv->host);
	self->priv->host = _tmp9_;
	_tmp11_ = uri;
	_tmp12_ = _tmp11_->port;
	if (_tmp12_ <= 0) {
		_tmp10_ = 5900;
	} else {
		xmlURI* _tmp13_;
		gint _tmp14_;
		_tmp13_ = uri;
		_tmp14_ = _tmp13_->port;
		_tmp10_ = _tmp14_;
	}
	self->priv->port = _tmp10_;
	_tmp15_ = self->priv->display;
	_tmp16_ = self->priv->saved_properties;
	_tmp16__length1 = self->priv->saved_properties_length1;
	boxes_box_config_save_properties (config, (GObject*) _tmp15_, _tmp16_, _tmp16__length1);
	_xmlFreeURI0 (uri);
	return self;
}


BoxesVncDisplay*
boxes_vnc_display_new_with_uri (BoxesBoxConfig* config,
                                const gchar* _uri,
                                GError** error)
{
	return boxes_vnc_display_construct_with_uri (BOXES_TYPE_VNC_DISPLAY, config, _uri, error);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static GtkWidget*
boxes_vnc_display_real_get_display (BoxesDisplay* base,
                                    gint n)
{
	BoxesVncDisplay * self;
	GtkWidget* result = NULL;
	GtkWindow* _tmp0_;
	VncDisplay* _tmp1_;
	VncDisplay* _tmp2_;
	GtkWidget* _tmp3_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = self->priv->window;
	_tmp1_ = self->priv->display;
	gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->display;
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
	result = _tmp3_;
	return result;
}


static void
boxes_vnc_display_real_set_enable_audio (BoxesDisplay* base,
                                         gboolean enable)
{
	BoxesVncDisplay * self;
	self = (BoxesVncDisplay*) base;
}


static GdkPixbuf*
boxes_vnc_display_real_get_pixbuf (BoxesDisplay* base,
                                   gint n,
                                   GError** error)
{
	BoxesVncDisplay * self;
	GdkPixbuf* result = NULL;
	VncDisplay* _tmp0_;
	GdkPixbuf* _tmp1_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = self->priv->display;
	_tmp1_ = vnc_display_get_pixbuf (_tmp0_);
	result = _tmp1_;
	return result;
}


static void
boxes_vnc_display_real_connect_it (BoxesDisplay* base,
                                   BoxesDisplayOpenFDFunc open_fd,
                                   gpointer open_fd_target,
                                   GDestroyNotify open_fd_target_destroy_notify,
                                   GError** error)
{
	BoxesVncDisplay * self;
	gboolean _tmp0_;
	VncDisplay* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	VncDisplay* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VncDisplay* _tmp7_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = ((BoxesDisplay*) self)->connected;
	if (_tmp0_) {
		(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
		open_fd = NULL;
		open_fd_target = NULL;
		open_fd_target_destroy_notify = NULL;
		return;
	}
	((BoxesDisplay*) self)->connected = TRUE;
	_tmp1_ = self->priv->display;
	_tmp2_ = boxes_display_get_username ((BoxesDisplay*) self);
	_tmp3_ = _tmp2_;
	vnc_display_set_credential (_tmp1_, (gint) VNC_DISPLAY_CREDENTIAL_USERNAME, _tmp3_);
	_tmp4_ = self->priv->display;
	_tmp5_ = boxes_display_get_password ((BoxesDisplay*) self);
	_tmp6_ = _tmp5_;
	vnc_display_set_credential (_tmp4_, (gint) VNC_DISPLAY_CREDENTIAL_PASSWORD, _tmp6_);
	_tmp7_ = self->priv->display;
	vnc_display_set_credential (_tmp7_, (gint) VNC_DISPLAY_CREDENTIAL_CLIENTNAME, "boxes");
	if (open_fd != NULL) {
		gint fd = 0;
		VncDisplay* _tmp8_;
		gint _tmp9_;
		const gchar* _tmp10_;
		fd = open_fd (open_fd_target);
		_tmp8_ = self->priv->display;
		_tmp9_ = fd;
		_tmp10_ = self->priv->host;
		vnc_display_open_fd_with_hostname (_tmp8_, _tmp9_, _tmp10_);
	} else {
		VncDisplay* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp11_ = self->priv->display;
		_tmp12_ = self->priv->host;
		_tmp13_ = self->priv->port;
		_tmp14_ = g_strdup_printf ("%i", _tmp13_);
		_tmp15_ = _tmp14_;
		vnc_display_open_host (_tmp11_, _tmp12_, _tmp15_);
		_g_free0 (_tmp15_);
	}
	(open_fd_target_destroy_notify == NULL) ? NULL : (open_fd_target_destroy_notify (open_fd_target), NULL);
	open_fd = NULL;
	open_fd_target = NULL;
	open_fd_target_destroy_notify = NULL;
}


static void
boxes_vnc_display_real_disconnect_it (BoxesDisplay* base)
{
	BoxesVncDisplay * self;
	VncDisplay* _tmp0_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = self->priv->display;
	if (vnc_display_is_open (_tmp0_)) {
		VncDisplay* _tmp1_;
		_tmp1_ = self->priv->display;
		vnc_display_close (_tmp1_);
	}
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static GList*
boxes_vnc_display_real_get_properties (BoxesDisplay* base,
                                       BoxesPropertiesPage page)
{
	BoxesVncDisplay * self;
	GList* result = NULL;
	GList* list = NULL;
	self = (BoxesVncDisplay*) base;
	list = NULL;
	result = list;
	return result;
}


static void
boxes_vnc_display_real_send_keys (BoxesDisplay* base,
                                  guint* keyvals,
                                  int keyvals_length1)
{
	BoxesVncDisplay * self;
	VncDisplay* _tmp0_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = self->priv->display;
	vnc_display_send_keys (_tmp0_, keyvals, keyvals_length1);
}


void
boxes_vnc_display_scale (BoxesVncDisplay* self)
{
	VncDisplay* _tmp0_;
	GtkAllocation alloc = {0};
	VncDisplay* _tmp1_;
	GtkContainer* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gdouble parent_aspect = 0.0;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	GtkAllocation _tmp6_;
	gint _tmp7_;
	gdouble display_aspect = 0.0;
	VncDisplay* _tmp8_;
	VncDisplay* _tmp9_;
	GtkAllocation scaled = {0};
	GtkAllocation _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	VncDisplay* _tmp29_;
	GtkAllocation _tmp30_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->display;
	if (!vnc_display_is_open (_tmp0_)) {
		return;
	}
	_tmp1_ = self->priv->display;
	_tmp2_ = gtk_widget_get_parent ((GtkWidget*) _tmp1_);
	gtk_widget_get_allocation ((GtkWidget*) _tmp2_, &_tmp3_);
	alloc = _tmp3_;
	_tmp4_ = alloc;
	_tmp5_ = _tmp4_.width;
	_tmp6_ = alloc;
	_tmp7_ = _tmp6_.height;
	parent_aspect = ((gdouble) _tmp5_) / ((gdouble) _tmp7_);
	_tmp8_ = self->priv->display;
	_tmp9_ = self->priv->display;
	display_aspect = ((gdouble) vnc_display_get_width (_tmp8_)) / ((gdouble) vnc_display_get_height (_tmp9_));
	_tmp10_ = alloc;
	scaled = _tmp10_;
	_tmp11_ = parent_aspect;
	_tmp12_ = display_aspect;
	if (_tmp11_ > _tmp12_) {
		GtkAllocation _tmp13_;
		gint _tmp14_;
		gdouble _tmp15_;
		gint _tmp16_;
		GtkAllocation _tmp17_;
		gint _tmp18_;
		GtkAllocation _tmp19_;
		gint _tmp20_;
		_tmp13_ = alloc;
		_tmp14_ = _tmp13_.height;
		_tmp15_ = display_aspect;
		scaled.width = (gint) (_tmp14_ * _tmp15_);
		_tmp16_ = scaled.x;
		_tmp17_ = alloc;
		_tmp18_ = _tmp17_.width;
		_tmp19_ = scaled;
		_tmp20_ = _tmp19_.width;
		scaled.x = _tmp16_ + ((_tmp18_ - _tmp20_) / 2);
	} else {
		GtkAllocation _tmp21_;
		gint _tmp22_;
		gdouble _tmp23_;
		gint _tmp24_;
		GtkAllocation _tmp25_;
		gint _tmp26_;
		GtkAllocation _tmp27_;
		gint _tmp28_;
		_tmp21_ = alloc;
		_tmp22_ = _tmp21_.width;
		_tmp23_ = display_aspect;
		scaled.height = (gint) (_tmp22_ / _tmp23_);
		_tmp24_ = scaled.y;
		_tmp25_ = alloc;
		_tmp26_ = _tmp25_.height;
		_tmp27_ = scaled;
		_tmp28_ = _tmp27_.height;
		scaled.y = _tmp24_ + ((_tmp26_ - _tmp28_) / 2);
	}
	_tmp29_ = self->priv->display;
	_tmp30_ = scaled;
	gtk_widget_size_allocate ((GtkWidget*) _tmp29_, &_tmp30_);
}


static const gchar*
boxes_vnc_display_real_get_protocol (BoxesDisplay* base)
{
	const gchar* result;
	BoxesVncDisplay* self;
	self = (BoxesVncDisplay*) base;
	result = "VNC";
	return result;
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static gchar*
boxes_vnc_display_real_get_uri (BoxesDisplay* base)
{
	gchar* result;
	BoxesVncDisplay* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	self = (BoxesVncDisplay*) base;
	_tmp0_ = self->priv->host;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = self->priv->port;
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("vnc://", _tmp1_, ":", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	return result;
}


static void
_boxes_vnc_display___lambda94_ (BoxesVncDisplay* self)
{
	g_signal_emit_by_name ((BoxesDisplay*) self, "show", 0);
	boxes_display_access_start ((BoxesDisplay*) self);
}


static void
__boxes_vnc_display___lambda94__vnc_display_vnc_initialized (VncDisplay* _sender,
                                                             gpointer self)
{
	_boxes_vnc_display___lambda94_ ((BoxesVncDisplay*) self);
}


static void
_boxes_vnc_display___lambda95_ (BoxesVncDisplay* self)
{
	g_signal_emit_by_name ((BoxesDisplay*) self, "hide", 0);
	boxes_display_access_finish ((BoxesDisplay*) self);
}


static void
__boxes_vnc_display___lambda95__vnc_display_vnc_disconnected (VncDisplay* _sender,
                                                              gpointer self)
{
	_boxes_vnc_display___lambda95_ ((BoxesVncDisplay*) self);
}


static void
_boxes_vnc_display___lambda96_ (BoxesVncDisplay* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	g_debug ("vnc-display.vala:42: auth failure");
	_tmp0_ = boxes_display_get_password ((BoxesDisplay*) self);
	_tmp1_ = _tmp0_;
	boxes_display_set_need_password ((BoxesDisplay*) self, _tmp1_ != NULL);
	_tmp2_ = boxes_display_get_username ((BoxesDisplay*) self);
	_tmp3_ = _tmp2_;
	boxes_display_set_need_username ((BoxesDisplay*) self, _tmp3_ != NULL);
}


static void
__boxes_vnc_display___lambda96__vnc_display_vnc_auth_failure (VncDisplay* _sender,
                                                              const gchar* object,
                                                              gpointer self)
{
	_boxes_vnc_display___lambda96_ ((BoxesVncDisplay*) self);
}


static void
_boxes_vnc_display___lambda97_ (BoxesVncDisplay* self)
{
	g_debug ("vnc-display.vala:48: auth unsupported");
}


static void
__boxes_vnc_display___lambda97__vnc_display_vnc_auth_unsupported (VncDisplay* _sender,
                                                                  guint object,
                                                                  gpointer self)
{
	_boxes_vnc_display___lambda97_ ((BoxesVncDisplay*) self);
}


static void
_boxes_vnc_display___lambda98_ (BoxesVncDisplay* self,
                                GValueArray* creds)
{
	VncDisplay* _tmp6_;
	g_return_if_fail (creds != NULL);
	{
		GValueArray* cred_collection = NULL;
		guint cred_index = 0U;
		cred_collection = creds;
		for (cred_index = 0; cred_index < cred_collection->n_values; cred_index = cred_index + 1) {
			GValue cred = {0};
			cred = *g_value_array_get_nth (cred_collection, cred_index);
			{
				VncDisplayCredential credential = 0;
				GValue _tmp0_;
				VncDisplayCredential _tmp1_;
				_tmp0_ = cred;
				credential = g_value_get_enum (&_tmp0_);
				_tmp1_ = credential;
				switch (_tmp1_) {
					case VNC_DISPLAY_CREDENTIAL_USERNAME:
					{
						boxes_display_set_need_username ((BoxesDisplay*) self, TRUE);
						break;
					}
					case VNC_DISPLAY_CREDENTIAL_PASSWORD:
					{
						boxes_display_set_need_password ((BoxesDisplay*) self, TRUE);
						break;
					}
					case VNC_DISPLAY_CREDENTIAL_CLIENTNAME:
					{
						break;
					}
					default:
					{
						VncDisplayCredential _tmp2_;
						GEnumValue* _tmp3_;
						gchar* _tmp4_;
						gchar* _tmp5_;
						_tmp2_ = credential;
						_tmp3_ = g_enum_get_value (g_type_class_ref (vnc_display_credential_get_type ()), _tmp2_);
						_tmp4_ = g_strdup_printf ("Unsupported credential: %s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
						_tmp5_ = _tmp4_;
						g_debug ("vnc-display.vala:68: %s", _tmp5_);
						_g_free0 (_tmp5_);
						break;
					}
				}
			}
		}
	}
	_tmp6_ = self->priv->display;
	vnc_display_close (_tmp6_);
}


static void
__boxes_vnc_display___lambda98__vnc_display_vnc_auth_credential (VncDisplay* _sender,
                                                                 GValueArray* credList,
                                                                 gpointer self)
{
	_boxes_vnc_display___lambda98_ ((BoxesVncDisplay*) self, credList);
}


static void
_boxes_vnc_display_scale_gtk_widget_size_allocate (GtkWidget* _sender,
                                                   GtkAllocation* allocation,
                                                   gpointer self)
{
	boxes_vnc_display_scale ((BoxesVncDisplay*) self);
}


static GObject *
boxes_vnc_display_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoxesVncDisplay * self;
	gchar* _tmp0_;
	GValue _tmp1_ = {0};
	BoxesBoxConfigSavedProperty _tmp2_ = {0};
	BoxesBoxConfigSavedProperty* _tmp3_;
	VncDisplay* _tmp4_;
	VncDisplay* _tmp5_;
	VncDisplay* _tmp6_;
	VncDisplay* _tmp7_;
	VncDisplay* _tmp8_;
	GtkWindow* _tmp9_;
	GtkWindow* _tmp10_;
	VncDisplay* _tmp11_;
	VncDisplay* _tmp12_;
	VncDisplay* _tmp13_;
	VncDisplay* _tmp14_;
	VncDisplay* _tmp15_;
	VncDisplay* _tmp16_;
	VncDisplay* _tmp17_;
	VncDisplay* _tmp18_;
	parent_class = G_OBJECT_CLASS (boxes_vnc_display_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplay);
	_tmp0_ = g_strdup ("read-only");
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp1_, FALSE);
	memset (&_tmp2_, 0, sizeof (BoxesBoxConfigSavedProperty));
	_g_free0 (_tmp2_.name);
	_tmp2_.name = _tmp0_;
	G_IS_VALUE (&_tmp2_.default_value) ? (g_value_unset (&_tmp2_.default_value), NULL) : NULL;
	_tmp2_.default_value = _tmp1_;
	_tmp3_ = g_new0 (BoxesBoxConfigSavedProperty, 1);
	_tmp3_[0] = _tmp2_;
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
	self->priv->saved_properties = _tmp3_;
	self->priv->saved_properties_length1 = 1;
	self->priv->_saved_properties_size_ = self->priv->saved_properties_length1;
	boxes_display_set_need_password ((BoxesDisplay*) self, FALSE);
	_tmp4_ = (VncDisplay*) vnc_display_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->display);
	self->priv->display = _tmp4_;
	_tmp5_ = self->priv->display;
	vnc_display_set_keyboard_grab (_tmp5_, TRUE);
	_tmp6_ = self->priv->display;
	vnc_display_set_pointer_grab (_tmp6_, TRUE);
	_tmp7_ = self->priv->display;
	vnc_display_set_force_size (_tmp7_, FALSE);
	_tmp8_ = self->priv->display;
	vnc_display_set_scaling (_tmp8_, TRUE);
	_tmp9_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp9_;
	_tmp10_ = self->priv->window;
	_tmp11_ = self->priv->display;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->display;
	gtk_widget_realize ((GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->display;
	g_signal_connect_object (_tmp13_, "vnc-initialized", (GCallback) __boxes_vnc_display___lambda94__vnc_display_vnc_initialized, self, 0);
	_tmp14_ = self->priv->display;
	g_signal_connect_object (_tmp14_, "vnc-disconnected", (GCallback) __boxes_vnc_display___lambda95__vnc_display_vnc_disconnected, self, 0);
	_tmp15_ = self->priv->display;
	g_signal_connect_object (_tmp15_, "vnc-auth-failure", (GCallback) __boxes_vnc_display___lambda96__vnc_display_vnc_auth_failure, self, 0);
	_tmp16_ = self->priv->display;
	g_signal_connect_object (_tmp16_, "vnc-auth-unsupported", (GCallback) __boxes_vnc_display___lambda97__vnc_display_vnc_auth_unsupported, self, 0);
	_tmp17_ = self->priv->display;
	g_signal_connect_object (_tmp17_, "vnc-auth-credential", (GCallback) __boxes_vnc_display___lambda98__vnc_display_vnc_auth_credential, self, 0);
	_tmp18_ = self->priv->display;
	g_signal_connect_object ((GtkWidget*) _tmp18_, "size-allocate", (GCallback) _boxes_vnc_display_scale_gtk_widget_size_allocate, self, 0);
	return obj;
}


static void
boxes_vnc_display_class_init (BoxesVncDisplayClass * klass)
{
	boxes_vnc_display_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BoxesVncDisplayPrivate));
	((BoxesDisplayClass *) klass)->get_display = (GtkWidget* (*) (BoxesDisplay*, gint)) boxes_vnc_display_real_get_display;
	((BoxesDisplayClass *) klass)->set_enable_audio = (void (*) (BoxesDisplay*, gboolean)) boxes_vnc_display_real_set_enable_audio;
	((BoxesDisplayClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (BoxesDisplay*, gint, GError**)) boxes_vnc_display_real_get_pixbuf;
	((BoxesDisplayClass *) klass)->connect_it = (void (*) (BoxesDisplay*, BoxesDisplayOpenFDFunc, gpointer, GDestroyNotify, GError**)) boxes_vnc_display_real_connect_it;
	((BoxesDisplayClass *) klass)->disconnect_it = (void (*) (BoxesDisplay*)) boxes_vnc_display_real_disconnect_it;
	((BoxesDisplayClass *) klass)->get_properties = (GList* (*) (BoxesDisplay*, BoxesPropertiesPage)) boxes_vnc_display_real_get_properties;
	((BoxesDisplayClass *) klass)->send_keys = (void (*) (BoxesDisplay*, guint*, int)) boxes_vnc_display_real_send_keys;
	BOXES_DISPLAY_CLASS (klass)->get_protocol = boxes_vnc_display_real_get_protocol;
	BOXES_DISPLAY_CLASS (klass)->get_uri = boxes_vnc_display_real_get_uri;
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_vnc_display_get_property;
	G_OBJECT_CLASS (klass)->constructor = boxes_vnc_display_constructor;
	G_OBJECT_CLASS (klass)->finalize = boxes_vnc_display_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_VNC_DISPLAY_PROTOCOL_PROPERTY, boxes_vnc_display_properties[BOXES_VNC_DISPLAY_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_VNC_DISPLAY_URI_PROPERTY, boxes_vnc_display_properties[BOXES_VNC_DISPLAY_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
boxes_vnc_display_instance_init (BoxesVncDisplay * self)
{
	self->priv = BOXES_VNC_DISPLAY_GET_PRIVATE (self);
}


static void
boxes_vnc_display_finalize (GObject * obj)
{
	BoxesVncDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplay);
	_g_object_unref0 (self->priv->display);
	_g_free0 (self->priv->host);
	_g_object_unref0 (self->priv->window);
	self->priv->saved_properties = (_vala_BoxesBoxConfigSavedProperty_array_free (self->priv->saved_properties, self->priv->saved_properties_length1), NULL);
	G_OBJECT_CLASS (boxes_vnc_display_parent_class)->finalize (obj);
}


GType
boxes_vnc_display_get_type (void)
{
	static volatile gsize boxes_vnc_display_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_vnc_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesVncDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_vnc_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesVncDisplay), 0, (GInstanceInitFunc) boxes_vnc_display_instance_init, NULL };
		GType boxes_vnc_display_type_id;
		boxes_vnc_display_type_id = g_type_register_static (BOXES_TYPE_DISPLAY, "BoxesVncDisplay", &g_define_type_info, 0);
		g_once_init_leave (&boxes_vnc_display_type_id__volatile, boxes_vnc_display_type_id);
	}
	return boxes_vnc_display_type_id__volatile;
}


static void
_vala_boxes_vnc_display_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	BoxesVncDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_VNC_DISPLAY, BoxesVncDisplay);
	switch (property_id) {
		case BOXES_VNC_DISPLAY_PROTOCOL_PROPERTY:
		g_value_set_string (value, boxes_display_get_protocol ((BoxesDisplay*) self));
		break;
		case BOXES_VNC_DISPLAY_URI_PROPERTY:
		g_value_take_string (value, boxes_display_get_uri ((BoxesDisplay*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



